<script lang="ts">
  export let userId: string;
  export let firstName: string | null;
  export let lastName: string | null;
  export let teamName: string | null = null;
  export let showName: boolean = true;
  export let small: boolean = false;
  export let nameOnRight: boolean = true;

  let backgroundColor: string;
  $: backgroundColor = createBackgroundColor(userId);

  /* Seeded PRNG, CC0 License */
  function mulberry32(a: number) {
    return function () {
      let t = (a += 0x6d2b79f5);
      t = Math.imul(t ^ (t >>> 15), t | 1);
      t ^= t + Math.imul(t ^ (t >>> 7), t | 61);
      return ((t ^ (t >>> 14)) >>> 0) / 4294967296;
    };
  }

  // Sourced from: https://stackoverflow.com/a/44134328
  function hslToHex(h: number, s: number, l: number) {
    const a = s * Math.min(l, 1 - l);
    const f = (n: number) => {
      const k = (n + h / 30) % 12;
      const color = l - a * Math.max(Math.min(k - 3, 9 - k, 1), -1);
      return Math.round(255 * color)
        .toString(16)
        .padStart(2, '0');
    };
    return `#${f(0)}${f(8)}${f(4)}`;
  }

  function createBackgroundColor(userId: string): string {
    let seed = Number(`0x${userId.replaceAll('-', '').substring(0, 8)}`);
    let seeded_RNG = mulberry32(seed);
    return hslToHex(seeded_RNG() * 360, 0.5, 0.5);
  }

  $: initials = `${(firstName || '?').substring(0, 1)}${(lastName || '?').substring(0, 1)}`;
  let size: number = 60;
  $: size = small ? 40 : 60;
</script>

<div class="d-inline-block align-middle">
  {#if showName && !nameOnRight}
    <div class="d-inline-block align-middle">
      {`${firstName} ${lastName}${teamName ? ` - ${teamName}` : ''}`}
    </div>
  {/if}
  <div
    class="rounded-circle d-inline-block text-white mx-1 align-middle"
    style={`background-color: ${backgroundColor}; height: ${size}px; width: ${size}px;`}
  >
    <div class={`text-center align-middle fs-${small ? 6 : 4}`} style={`width: ${size}px; line-height: ${size}px;`}>
      {initials}
    </div>
  </div>
  {#if showName && nameOnRight}
    <div class="d-inline-block align-middle">
      {`${firstName || ''} ${lastName || ''}${teamName ? ` - ${teamName}` : ''}`}
    </div>
  {/if}
</div>
